<script>
  import { exportKml } from 'cesium'
  import { createEventDispatcher } from 'svelte'
  import { onDestroy, onMount, stop_propagation } from 'svelte/internal'
  const dispatch = createEventDispatcher()
  export let device
  let expanded = false
  let command = ''
  let commandSent = false
  let commandResponse
  let temperature = 0
  let weather = ''
  let weatherConditions

  onMount(async () => {
    fetchWeather()
    // Fetch weather every hour
    const intervalId = setInterval(fetchWeather, 3600000)
  })

  onDestroy(() => {
    clearInterval(intervalId)
  })

  async function fetchWeather() {
    try {
      const response = await fetch(
        process.env.API_BASE_URL +
          '/weather' +
          '?lat=' +
          device.location.latitude +
          '&lon=' +
          device.location.longitude,
      ).catch((error) => console.error('Error fetching weatjer: ', error))
      weatherConditions = await response.json()
      temperature = weatherConditions.temperature
      weather = weatherConditions.weather
    } catch (error) {
      console.error('Error fetching weather: ', error)
    }
  }

  function toggleExpand() {
    expanded = !expanded
    if (expanded) {
      dispatch('select', {
        latitude: device.location.latitude,
        longitude: device.location.longitude,
      })
    } else {
      dispatch('unselect')
    }
  }

  async function sendCommand() {
    commandResponse = null
    commandSent = true
    try {
      const response = await fetch(process.env.API_BASE_URL + '/send-command', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
        },
        body: JSON.stringify({ node_id: device.node_id, command: command }),
      })
      if (!response.ok) {
        throw new Error('HTTP error: ${response.status')
      }
      commandResponse = await response.json()
    } catch (error) {
      console.error('Error sending command: ', error)
    }
  }

  function handleKeydown(event) {
    if (event.key === 'Enter') {
      sendCommand()
    }
  }
</script>

<style>
  .device-card {
    border: 1px solid #000;
    border-radius: 25px;
    padding: 10px;
    margin: 5px;
    cursor: pointer;
  }

  .device-card .details {
    margin-top: 10px;
  }

  .response-text {
    max-height: 200px;
    overflow-y: auto;
    background: #f8f8f8;
    border: 1px solid #ccc;
    padding: 10px;
  }
</style>

<div class="device-card" on:click={toggleExpand}>
  <h3>{device.node_id}</h3>
  {#if expanded}
    <div class="details">
      <p>Device ID: {device.node_id}</p>
      <p>Location: {device.location.latitude}, {device.location.longitude}</p>
      <!-- TODO add weather -->
      <p>Weather: {temperature} C, {weather}</p>
      <input
        type="text"
        bind:value={command}
        on:keydown={handleKeydown}
        on:click|stopPropagation
        placeholder="Enter u-blox command" />
      <button on:click={sendCommand} on:click|stopPropagation>Send</button>
      {#if commandSent}
        <div class="response-text" on:click|stopPropagation>
          <pre>
            {commandResponse ? commandResponse.response : 'Waiting for response...'}
          </pre>
        </div>
      {/if}
    </div>
  {/if}
</div>
